/* $Id: ha.h,v 1.13 2001/02/17 18:19:09 jm Exp $
 * Header file for Home Agent
 *
 * Dynamic hierarchial IP tunnel
 * Copyright (C) 1998-2001, Dynamics group
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation. See README and COPYING for
 * more details.
 */

#ifndef HA_H
#define HA_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "owntypes.h"
#define HA_CONF_FILE         "dynhad.conf"
#define HA_GLOBAL_CONF_FILE  SYSCONFDIR "/" HA_CONF_FILE 

/* The process id of the daemon is saved here to make it easier to
   kill the correct daemon when necessary. */
#define HA_PID_FILE          PIDDIR "/dynhad.pid"

enum { ENCAPS_IPIP, ENCAPS_MINIMAL, ENCAPS_GRE };
enum { AUTH_RFC2002, AUTH_RFC2002BIS };

struct ha_tunnel_data {
	struct in_addr lower_saddr; /* source address of the request */
	__u32 nonce; /* last sent nonce */
	unsigned char auth_type; /* AUTH_RFC2002 for RFC 2002bis MAC
				  * calculation (i.e., include the SPI field);
				  * AUTH_RFC2002BIS for RFC 2002 MAC
				  * calculation */
	int reverse_tunnel; /* 0 = triangle, 1 = reverse */
	int encapsulation; /* encapsulation type */
	char arp_if[IFNAMSIZ]; /* interface used for proxy ARP entry */
	time_t last_failure_time; /* time of the last failure reply */
};

#endif /* HA_H */
