/* $Id: mn_handler.h,v 1.9 2001/09/29 16:06:39 jm Exp $
 * Header files for Mobile Node handler module
 *
 * Dynamic hierarchial IP tunnel
 * Copyright (C) 1998-2000, Dynamics group
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation. See README and COPYING for
 * more details.
 */

#ifndef MN_HANDLER_H
#define MN_HANDLER_H

#include <time.h>
#include "mn_agentadv.h"
#include "mn.h"
#include "hashtable.h"

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#define MICRO_SECONDS_TO_WAIT_INFO_REPLY 500000

/* handler structure */
struct handler {
	struct node listnode;
	int (*func)(void *data);
};

/* Foreign Agent related events */
#define FA_ADV_EXPIRE      0
#define FA_ADV_RECEIVE     1
#define FA_GET             2

struct event_FA {
	struct agentadv_data *adv;
	struct hashtable *hash; /* all advertisements */
};

/* Interface handling events */
#define INTERFACE_INIT     3
#define INTERFACE_DOWN     4

struct event_INTERFACE {
	struct interface_data *iface;
	char *ifname;       /* iface->device */
	int *index;         /* &iface->index */
	int *priority;      /* &iface->priority */
	int *icmp_sock;     /* &iface->s */
	int *icmp_sock_adv; /* &iface->s_adv */
	struct timeval *last_reg_send_time; /* &mn.last_reg_send_time */
	struct agentadv_data **current_adv; /* &mn.current_adv */
	struct idxmap *idx;
};

/* Handler functions */
int handler_unregister(int event_type, int (*func)(void *data));
int handler_register(int event_type, int (*func)(void *data));
int handler_unregister_all(int event_type);
int handler_call_all(int event_type, void *data);
int mn_handlers_init(void);

#endif
