/* $Id: msgparser.h,v 1.24 2001/07/13 17:07:29 jm Exp $
 * Parsing of Registration Request and Reply Messages
 *
 * Dynamic hierarchial IP tunnel
 * Copyright (C) 1998-2001, Dynamics group
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation. See README and COPYING for
 * more details.
 */

#ifndef MSGPARSER_H
#define MSGPARSER_H

#include "message.h"

#define DOUBLE_MH_AUTH 0x01
#define DOUBLE_MF_AUTH 0x02
#define DOUBLE_FH_AUTH 0x04
#define DOUBLE_FF_AUTH 0x08
#define DOUBLE_SK_AUTH 0x10
#define DOUBLE_SHA_HA_AUTH 0x20

struct msg_extensions {
	char *start;
	int len;

	struct reg_req *req;
	struct reg_rep *rep;
	struct msg_auth *mh_auth;
	struct msg_auth *mf_auth;
	struct msg_auth *fh_auth;
	struct vendor_msg_auth *ff_auth;
	struct vendor_msg_auth *sk_auth;
	struct msg_key *fa_keyreq;
	struct msg_key *fa_pubkey;
	struct msg_key *mn_keyreq;
	struct msg_key *mn_keyrep;
	struct msg_key *fa_keyrep;
	struct msg_key *fa_pubkeyrep;
	struct registration_ext_dynamics *ext_dyn;
	struct msg_key *pubkey_hash;
	struct encaps_delivery_ext *encaps_del;
	struct fa_nai_ext *fa_nai;
	struct fa_nai_ext *prev_fa_nai;
	struct gre_key_ext *gre_key;
	struct sfa_debug_ext *sfa_debug;
	struct fa_reg_req *fa_req;
	struct fa_reg_rep *fa_rep;
	struct mn_nai_ext *mn_nai;
	struct priv_ha_ext *priv_ha;
	struct vendor_msg_auth *sha_ha_auth;
	struct nonce_ext *nonce;
	struct challenge_ext *challenge;
	struct generalized_auth_ext *mn_aaa_auth;
	struct generalized_mn_fa_key_req_ext *mn_fa_key_req_aaa;
	struct generalized_mn_fa_key_rep_ext *mn_fa_key_material_aaa;
	struct generalized_mn_ha_key_req_ext *mn_ha_key_req_aaa;
	struct generalized_mn_ha_key_rep_ext *mn_ha_key_material_aaa;

	/* bitfield of duplicate authentication extensions */
	unsigned char double_auth_ext;
	int unknown_cvse; /* RFC 3025: unknown critical vendor specific ext. */
};

int parse_msg(char *msg_start, int len, struct msg_extensions *ext);

#endif
