/* $Id: proxyarp.h,v 1.9 2000/11/17 17:49:58 jm Exp $
 * ARP interface
 *
 * Dynamic hierarchial IP tunnel
 * Copyright (C) 1998-2000, Dynamics group
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation. See README and COPYING for
 * more details.
 */

#ifndef PROXYARP_H
#define PROXYARP_H

#include "config.h"

#include <netinet/in.h>

#ifdef DYN_TARGET_LINUX
#if __GLIBC__ >= 2 && __GLIBC_MINOR__ >= 1
#include <net/ethernet.h>     /* the L2 protocols */
#include <netinet/if_ether.h>
#else
#include <linux/if_ether.h>   /* The L2 protocols */
#endif
#endif

#ifdef DYN_TARGET_WINDOWS
#include "windows_extra.h"
#endif

int arp_add_permanent_item(struct in_addr host_addr,
			   char const *interface, struct sockaddr *eth);
int arp_del_permanent_item(struct in_addr host_addr, char const *interface);
int proxyarp_add_item(struct in_addr host_addr, char const *interface);
int proxyarp_del_item(struct in_addr host_addr, char const *interface);
int proxyarp_gratuitous(struct in_addr host_addr, char const *interface);

#endif
