/* $Id: sha_config.h,v 1.2 2000/04/06 07:26:53 jm Exp $
 * Surrogate Home Agent configuration processing
 *
 * Dynamic hierarchial IP tunnel
 * Copyright (C) 2000, Dynamics group
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation. See README and COPYING for
 * more details.
 */

#ifndef SHA_CONFIG_H
#define SHA_CONFIG_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <net/if.h>
#include "list.h"
#include "message.h"

#define SHA_CONF_FILE "dynshad.conf"
#define SHA_GLOBAL_CONF_FILE SYSCONFDIR "/" SHA_CONF_FILE 


#define MAXSHAREDSECRETLEN 32

struct sha_spi_entry {
	struct node node;
	int spi;
	struct in_addr addr;
	__u32 priv_ha; /* 0 = FA, >0 = private HA identifier */
	int alg;
	unsigned char shared_secret[MAXSHAREDSECRETLEN];
	int shared_secret_len;
};

#define MAX_HASH_LEN 16

struct sha_config {
	struct in_addr sha_addr;
	char tunnel_device[IFNAMSIZ + 1];
	int udp_port;
	int routing_table_start;
	int routing_table_end;
        int max_bindings;
        int max_lifetime;
        int syslog_facility;
	struct list sha_spi_list;
	int socket_priority;
};

struct load_sha_data {
        struct sha_config *cfg;
	int process_sha_spi_list;
};


int load_sha(struct sha_config *sha, char *program_name, char *config_file);
void cleanup_sha_config(struct sha_config *config);


#endif
