/* $Id: debug.h,v 1.9 2001/08/05 17:32:51 jm Exp $
 * Header files for debugging functions
 *
 * Dynamic hierarchial IP tunnel
 * Copyright (C) 1998-2001, Dynamics group
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation. See README and COPYING for
 * more details.
 */

#ifndef DEBUG_H
#define DEBUG_H

#include <stdio.h>
#include <stdarg.h>

/* DEBUG */

#ifdef NODEBUGMODE
#define DEBUG nodebug
#define DEBUG_HEXDUMP(...)
#else
#define DEBUG debug
#define DEBUG_HEXDUMP debug_hexdump
#endif

/* prototypes */
#define CHECK_FORMAT __attribute__ ((format (printf, 2, 3)))
void debug(char flag, char *format, ...) CHECK_FORMAT;
void nodebug(char flag, char *format, ...) CHECK_FORMAT;
void debug_hexdump(char flag, const char *title, const unsigned char *buf,
		   int len);

#endif /* DEBUG_H */
